require "helper"
require "fluent/plugin/out_multi_condition_selector.rb"

class MultiConditionSelectorOutputText < Test::Unit::TestCase
  setup do
    Fluent::Test.setup
  end

  def create_driver(conf)
    Fluent::Test::Driver::Output.new(Fluent::Plugin::MultiConditionSelectorOutput).configure(conf)
  end

  test "simple_configure" do
    conf = config_element(
      'ROOT',
      '',
      {'tag' => "speak_chekc"},
      [
        config_element(
          'condition',
          '',
          {
            'rule' => 'record["action"] == "speak"',
            'condition' => 'speaking'
          },
          [
            config_element(
              'data',
              '',
              {
                'new_word' => 'record["word"] + "こんにちは"',
                'aaa' => 1
              },
              []
            )
          ]
        ),
        config_element(
          'condition',
          '',
          {
            'rule' => 'record["action"] != "speak"',
            'condition' => 'no_speak'
          },
          [
            config_element(
              'data',
              '',
              {
                'new_word' => 'record["word"] + "はじめまして"'
              },
              []
            )
          ]
        )
      ]
    )
    d = create_driver(conf)
    d.run(default_tag: 'test') do
      record = {
        'action' => "speak",
        "word" => "aaa"
      }
      d.feed(record)
      events = d.events
      pp events
    end
  end

  private

  def create_driver(conf)
    Fluent::Test::Driver::Output.new(Fluent::Plugin::MultiConditionSelectorOutput).configure(conf)
  end
end
